
/* =========================================================================== *
|
|  Copyright (c) 1994-2008 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowledged in publications, and relevant papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarantee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef I_DISPLAY_INCLUDED
#define I_DISPLAY_INCLUDED

#include "l/l_def.h"
#include "i/i_type.h"

#ifdef __cplusplus
extern "C" {
#ifdef COMPILING_CPLUSPLUS_SOURCE
namespace kjb_c {
#endif
#endif

/* -------------------------------------------------------------------------- */

int set_display_options(const char* option, const char* value);

int display_any_image
(
    const void* ip,
    const char* title,
    int         (*image_write_fn) (const void*, char*)
);

int create_image_display(void);
int close_displayed_image(int image_num);
void destroy_image_display(void);

int fork_display_any_image
(
    const void* ip,
    const char* title,
    int         (*image_write_fn) (const void*, char*)
);

#ifdef __cplusplus
#ifdef COMPILING_CPLUSPLUS_SOURCE
}
#endif
}
#endif

#endif

